Index: config.sample.inc.php
===================================================================
--- config.sample.inc.php	(revision 12659)
+++ config.sample.inc.php	(working copy)
@@ -41,6 +41,24 @@
 $cfg['Servers'][$i]['bs_temp_blob_timeout'] = 600;
 $cfg['Servers'][$i]['bs_temp_log_threshold'] = '32M';
 
+/* @zixan | config vars for permanent storage feature */
+$cfg['perm_storage'][$i]['root'] =  TRUE;
+$cfg['perm_storage'][$i]['font_size'] = TRUE;
+$cfg['perm_storage'][$i]['navi_width'] = TRUE;
+$cfg['perm_storage'][$i]['max_rows'] = TRUE;
+$cfg['perm_storage'][$i]['foreign_key_max_limit'] = TRUE;
+$cfg['perm_storage'][$i]['properties_iconic'] = TRUE;
+$cfg['perm_storage'][$i]['properties_num_cols'] = TRUE;
+$cfg['perm_storage'][$i]['left_frame_light'] = TRUE;
+$cfg['perm_storage'][$i]['use_db_search'] = TRUE;
+$cfg['perm_storage'][$i]['max_db_list'] = TRUE;
+$cfg['perm_storage'][$i]['max_table_list'] = TRUE;
+$cfg['perm_storage'][$i]['full_text'] = TRUE;
+$cfg['perm_storage'][$i]['login_cookie_validity'] = TRUE;
+$cfg['perm_storage'][$i]['nav_bar_iconic'] = TRUE;
+$cfg['perm_storage'][$i]['default_lang'] = TRUE;
+
+
 /* User for advanced features */
 // $cfg['Servers'][$i]['controluser'] = 'pma';
 // $cfg['Servers'][$i]['controlpass'] = 'pmapass';
Index: libraries/config.default.php
===================================================================
--- libraries/config.default.php	(revision 12659)
+++ libraries/config.default.php	(working copy)
@@ -80,7 +80,126 @@
  */
 $cfg['blowfish_secret'] = '';
 
+/*******************************************************************************
+ * @zixan
+ * Permanent Storage configuration
+ *
+ * The $cfg['perm_storage'] array starts with $cfg['perm_storage'][1].  Do not use
+ * $cfg['perm_storage'][0]. You can disable a setting by making it's value equal to
+ * false.  To enable, make the value equal to TRUE.
+ *
+ * @global array $cfg['perm_storage']
+ */
+$cfg['perm_storage'] = array();
 
+$i = 1;
+
+/**
+ * Enable/disable the entire permanent storage feature
+ *
+ * @global bool $cfg['perm_storage'][$i]['root']
+ */
+$cfg['perm_storage'][$i]['root'] =  TRUE;
+
+/**
+ * Enable/disable permanent storage for font size
+ *
+ * @global bool $cfg['perm_storage'][$i]['font_size']
+ */
+$cfg['perm_storage'][$i]['font_size'] = TRUE;
+
+/**
+ * Enable/disable permanent storage for navi width
+ *
+ * @global bool $cfg['perm_storage'][$i]['navi_width']
+ */
+$cfg['perm_storage'][$i]['navi_width'] = TRUE;
+
+/**
+ * Enable/disable permanent storage for max rows
+ *
+ * @global bool $cfg['perm_storage'][$i]['max_rows']
+ */
+$cfg['perm_storage'][$i]['max_rows'] = TRUE;
+
+/**
+ * Enable/disable permanent storage for foreign key max limit
+ *
+ * @global bool $cfg['perm_storage'][$i]['foreign_key_max_limit']
+ */
+$cfg['perm_storage'][$i]['foreign_key_max_limit'] = TRUE;
+
+/**
+ * Enable/disable permanent storage for properties iconic
+ *
+ * @global bool $cfg['perm_storage'][$i]['properties_iconic']
+ */
+$cfg['perm_storage'][$i]['properties_iconic'] = TRUE;
+
+/**
+ * Enable/disable permanent storage for properties num cols
+ *
+ * @global bool $cfg['perm_storage'][$i]['properties_num_cols']
+ */
+$cfg['perm_storage'][$i]['properties_num_cols'] = TRUE;
+
+/**
+ * Enable/disable permanent storage for left frame light
+ *
+ * @global bool $cfg['perm_storage'][$i]['left_frame_light']
+ */
+$cfg['perm_storage'][$i]['left_frame_light'] = TRUE;
+
+/**
+ * Enable/disable permanent storage for use db search
+ *
+ * @global bool $cfg['perm_storage'][$i]['use_db_search']
+ */
+$cfg['perm_storage'][$i]['use_db_search'] = TRUE;
+
+/**
+ * Enable/disable permanent storage for max db list
+ *
+ * @global bool $cfg['perm_storage'][$i]['max_db_list']
+ */
+$cfg['perm_storage'][$i]['max_db_list'] = TRUE;
+
+/**
+ * Enable/disable permanent storage for max table list
+ *
+ * @global bool $cfg['perm_storage'][$i]['max_table_list']
+ */
+$cfg['perm_storage'][$i]['max_table_list'] = TRUE;
+
+/**
+ * Enable/disable permanent storage for full text
+ *
+ * @global bool $cfg['perm_storage'][$i]['full_text']
+ */
+$cfg['perm_storage'][$i]['full_text'] = TRUE;
+
+/**
+ * Enable/disable permanent storage for login cookie validity
+ *
+ * @global bool $cfg['perm_storage'][$i]['login_cookie_validity']
+ */
+$cfg['perm_storage'][$i]['login_cookie_validity'] = TRUE;
+
+/**
+ * Enable/disable permanent storage for nav bar iconic
+ *
+ * @global bool $cfg['perm_storage'][$i]['nav_bar_iconic']
+ */
+$cfg['perm_storage'][$i]['nav_bar_iconic'] = TRUE;
+
+/**
+ * Enable/disable permanent storage for default lang
+ *
+ * @global bool $cfg['perm_storage'][$i]['default_lang']
+ */
+$cfg['perm_storage'][$i]['default_lang'] = TRUE;
+
+
 /*******************************************************************************
  * Server(s) configuration
  *